4 USAGE='<fetch-options> <repository> <refspec>...'
7 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
20 while case "$#" in 0) break ;; esac
23 -a|--a|--ap|--app|--appe|--appen|--append)
26 -f|--f|--fo|--for|--forc|--force)
29 -t|--t|--ta|--tag|--tags)
32 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
35 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
36 --update-he|--update-hea|--update-head|--update-head-|\
37 --update-head-o|--update-head-ok)
55 test -f "$GIT_DIR/branches/origin" ||
56 test -f "$GIT_DIR/remotes/origin" ||
57 die "Where do you want to fetch from today?"
62 remote=$(get_remote_url "$@")
65 rsync_slurped_objects=
67 if test "" = "$append"
69 : >"$GIT_DIR/FETCH_HEAD"
72 append_fetch_head () {
79 t) not_for_merge_='not-for-merge' ;;
80 '') not_for_merge_= ;;
83 # remote-nick is the URL given on the command line (or a shorthand)
84 # remote-name is the $GIT_DIR relative refs/ path we computed
86 case "$remote_name_" in
90 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
91 note_="branch '$note_' of " ;;
93 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
94 note_="tag '$note_' of " ;;
96 note_="$remote_name of " ;;
98 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
100 note_="$note_$remote_"
102 # 2.6.11-tree tag would not be happy to be fed to resolve.
103 if git-cat-file commit "$head_" >/dev/null 2>&1
105 headc_=$(git-rev-parse --verify "$head_^0") || exit
106 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
107 [ "$verbose" ] && echo >&2 "* committish: $head_"
108 [ "$verbose" ] && echo >&2 " $note_"
110 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
111 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
112 [ "$verbose" ] && echo >&2 " $note_"
114 if test "$local_name_" != ""
116 # We are storing the head locally. Make sure that it is
117 # a fast forward (aka "reverse push").
118 fast_forward_local "$local_name_" "$head_" "$note_"
122 fast_forward_local () {
123 mkdir -p "$(dirname "$GIT_DIR/$1")"
126 # Tags need not be pointing at commits so there
127 # is no way to guarantee "fast-forward" anyway.
128 if test -f "$GIT_DIR/$1"
130 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
132 [ "$verbose" ] && echo >&2 "* $1: same as $3"
134 echo >&2 "* $1: updating with $3"
137 echo >&2 "* $1: storing $3"
139 git-update-ref "$1" "$2"
143 # $1 is the ref being updated.
144 # $2 is the new value for the ref.
145 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
148 # Require fast-forward.
149 mb=$(git-merge-base "$local" "$2") &&
152 echo >&2 "* $1: same as $3"
155 echo >&2 "* $1: fast forward to $3"
156 git-update-ref "$1" "$2" "$local"
162 echo >&2 "* $1: does not fast forward to $3;"
163 case ",$force,$single_force," in
165 echo >&2 " forcing update."
166 git-update-ref "$1" "$2" "$local"
169 echo >&2 " not updating."
174 echo >&2 "* $1: storing $3"
175 git-update-ref "$1" "$2"
181 case "$update_head_ok" in
183 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
187 # If --tags (and later --heads or --all) is specified, then we are
188 # not talking about defaults stored in Pull: line of remotes or
189 # branches file, and just fetch those and refspecs explicitly given.
190 # Otherwise we do what we always did.
192 reflist=$(get_remote_refs_for_fetch "$@")
196 git-ls-remote --tags "$remote" |
202 if git-check-ref-format "$name"
204 echo ".${name}:${name}"
206 echo >&2 "warning: tag ${name} ignored"
211 # remote URL plus explicit refspecs; we need to merge them.
212 reflist="$reflist$LF$taglist"
214 # No explicit refspecs; fetch tags only.
227 # These are relative path from $GIT_DIR, typically starting at refs/
229 if expr "$ref" : '\.' >/dev/null
232 ref=$(expr "$ref" : '\.\(.*\)')
236 if expr "$ref" : '\+' >/dev/null
239 ref=$(expr "$ref" : '\+\(.*\)')
243 remote_name=$(expr "$ref" : '\([^:]*\):')
244 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
246 rref="$rref$LF$remote_name"
248 # There are transports that can fetch only one head at a time...
250 http://* | https://*)
251 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
254 remote_name_quoted=$(perl -e '
256 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
259 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
260 expr "$head" : "$_x40\$" >/dev/null ||
261 die "Failed to fetch $remote_name from $remote"
262 echo >&2 Fetching "$remote_name from $remote" using http
263 git-http-fetch -v -a "$head" "$remote/" || exit
266 TMP_HEAD="$GIT_DIR/TMP_HEAD"
267 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
268 head=$(git-rev-parse --verify TMP_HEAD)
270 test "$rsync_slurped_objects" || {
271 rsync -av --ignore-existing --exclude info \
272 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
274 # Look at objects/info/alternates for rsync -- http will
275 # support it natively and git native ones will do it on
276 # the remote end. Not having that file is not a crime.
277 rsync -q "$remote/objects/info/alternates" \
278 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
279 rm -f "$GIT_DIR/TMP_ALT"
280 if test -f "$GIT_DIR/TMP_ALT"
282 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
285 case "$alt" in 'bad alternate: '*) die "$alt";; esac
286 echo >&2 "Getting alternate: $alt"
287 rsync -av --ignore-existing --exclude info \
288 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
290 rm -f "$GIT_DIR/TMP_ALT"
292 rsync_slurped_objects=t
296 # We will do git native transport with just one call later.
300 append_fetch_head "$head" "$remote" \
301 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
306 http://* | https://* | rsync://* )
307 ;; # we are already done.
309 ( : subshell because we muck with IFS
312 git-fetch-pack "$remote" $rref || echo failed "$remote"
314 while read sha1 remote_name
318 echo >&2 "Fetch failure: $remote"
346 local_name=$(expr "$found" : '[^:]*:\(.*\)')
347 append_fetch_head "$sha1" "$remote" \
348 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
355 fetch_main "$reflist"
357 # automated tag following
358 case "$no_tags$tags" in
361 git-ls-remote --tags "$remote" |
362 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
365 test -f "$GIT_DIR/$name" && continue
366 git-check-ref-format "$name" || {
367 echo >&2 "warning: tag ${name} ignored"
370 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
371 echo >&2 "Auto-following $name"
372 echo ".${name}:${name}"
377 fetch_main "$taglist" ;;
381 # If the original head was empty (i.e. no "master" yet), or
382 # if we were told not to worry, we do not have to check.
383 case ",$update_head_ok,$orig_head," in
387 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
388 if test "$curr_head" != "$orig_head"
390 git-update-ref HEAD "$orig_head"
391 die "Cannot fetch into the current branch."